
;;;*****************Hauptprogramm***************************

(defun C:0-PL (/               MD_LINE         MD_2DPOLYLINE
               MD_LWPOLYLINE   MD_TEXT         MD_ATTDEF
               M:FEHLER        ELEM1           ENAME
               POLY_ERSTE      L_LISTE         MD_LAENGE_AUSWAHLSATZ
               MD_ZAEHLER      oldcmd
               )
  (vl-load-com)
  (setq M:MD_ERR *ERROR*
        *ERROR*  M:FEHLER
        ) ;_ end of setq
  (command "_.UNDO" "_MARK")
  (setq oldcmd (getvar"cmdecho"))
  (setvar "cmdecho" 0)

;;;*************************md_line***************************************

  (defun MD_LINE (ENAME / P1 P2)
    (setq P1 (cdr (assoc 10 (entget ENAME)))
          P2 (cdr (assoc 11 (entget ENAME)))
          ) ;_ end of setq
    (if (equal P1 P2 0.001)
      (progn
        (setq L_LISTE (cons ENAME L_LISTE))
        (entdel ENAME)
        )                               ;ende progn
      )                                 ;ende if
    )                                   ;ende defun

;;;**************************MD_2DPOLYLINE******************************************


  (defun MD_2DPOLYLINE (ENAME    /        VERCOUNTER        ENT
                        PTSTART  PTEND    XSTART   YSTART   ZSTART
                        XEND     YEND     ZEND
                        )
    (setq ENAME (entget ENAME))
    (setq VERCOUNTER 0)
    (while (/= (cdr (assoc 0 ENAME)) "SEQEND")
      (setq ENAME (entget (entnext (cdr (assoc -1 ENAME)))))
      (setq VERCOUNTER (1+ VERCOUNTER))
      )                                 ;ende while
    (cond
      ((= VERCOUNTER 1)
       (setq L_LISTE (cons ENAME L_LISTE))
       (entdel ENAME)
       )
      ((= VERCOUNTER 2)
       (setq L_LISTE (cons ENAME L_LISTE))
       (entdel ENAME)
       )
      ((and
         (= VERCOUNTER 3)
         (/= (cdr(assoc 0 ENAME))"SEQEND")
         )
       (setq ENT (entget (entnext ENAME)))
       (setq PTSTART (cdr (assoc 10 ENT)))
       (setq ENT (entget (entnext (cdr (assoc -1 ENT)))))
       (setq PTEND (cdr (assoc 10 ENT)))
       (setq XSTART (car PTSTART))
       (setq YSTART (nth 1 PTSTART))
       (setq ZSTART (nth 2 PTSTART))
       (setq XEND (car PTEND))
       (setq YEND (nth 1 PTEND))
       (setq ZEND (nth 2 PTEND))
       (if (equal XSTART XEND 0.001)
         (if (equal YSTART YEND 0.001)
           (if (equal ZSTART ZEND 0.001)
             (progn
               (setq L_LISTE (cons ENAME L_LISTE))
               (entdel ENAME)
               ) ;_ end of progn
             )                          ;ende if
           )                            ;ende if
         )                              ;ende if
       )                                ;ende if
      ) ;_ end of cond
    )                                   ;ende defun md_polyline

;;;**************************LWPOLYLINE*********************************

  (defun MD_LWPOLYLINE (ENAME / LI)


;;;****************erstellen einer Liste aller Sttzpunkte************
    (setq LI NIL
          xn 0
          ) ;_ end of setq
    (mapcar
      '(lambda (X)
         (if (= (car X) 10)
           (progn
             (setq LI
                    (cond
                      ((= (length (cdr X)) 2)
                       (append LI
                               (list (list (atof (rtos (nth 0 (cdr X)) 2 6))
                                           (atof (rtos (nth 1 (cdr X)) 2 6))
                                           ) ;_ end of list
                                     ) ;_ end of list
                               ) ;_ end of append
                       )
                      ((= (length (cdr X)) 3)
                       (append LI
                               (list (list (atof (rtos (nth 0 (cdr X)) 2 6))
                                           (atof (rtos (nth 1 (cdr X)) 2 6))
                                           (atof (rtos (nth 2 (cdr X)) 2 6))
                                           ) ;_ end of list
                                     ) ;_ end of list
                               ) ;_ end of append
                       )
                      ) ;_ end of cond
                   )                    ;ende setq
             )                          ;ende progn
           X
           )                            ;ende if
         )                              ;ende lambda
      (entget ENAME)
      )                                 ;ende mapcar

;;;*************alle LWPL Mit gleichem X UND Y Wert lschen *************

    (if
      (and
        (= (length LI) 2)
        (equal (car LI)
               (cadr LI)
               0.001
               ) ;_ end of equal
        ) ;_ end of and
       (progn
         (entdel ENAME)
         (setq L_LISTE (cons ENAME L_LISTE))
         )                              ;ende progn
       )                                ;ende if
    (if
      (and
        (> (length LI) 2)
        (< (length LI) 6)
        (equal (car LI)
               (cadr LI)
               0.001
               ) ;_ end of equal
        (equal (car LI)
               (caddr LI)
               0.001
               ) ;_ end of equal
        (equal (cadr LI)
               (caddr LI)
               0.001
               ) ;_ end of equal
        ) ;_ end of and
       (progn
         (entdel ENAME)
         (setq L_LISTE (cons ENAME L_LISTE))
         )                              ;ende progn
       )                                ;ende if
    )                                   ;ende defun


;;;**********************md_text****************************

  (defun MD_TEXT (ENAME / txt_tmp)
    (setq txt_tmp (vl-remove 92
                             (vl-string->list (cdr (assoc 1 (entget ENAME))))
                             ) ;_ end of vl-remove
          txt_tmp (vl-list->string (vl-remove 80 txt_tmp))
          ) ;_ end of setq
    (if (= (vl-string-trim " " txt_tmp) "")
      (progn
        (setq L_LISTE (cons ENAME L_LISTE))
        (entdel ENAME)
        )                               ;ende progn
      )                                 ;ende if
    )                                   ;ende defun

;;;**********************md_attdef****************************
  (defun MD_ATTDEF (ENAME /)
    (if (= (cdr (assoc 2 (entget ENAME))) "")
      (progn
        (setq L_LISTE (cons ENAME L_LISTE))
        (entdel ENAME)
        )                               ;ende progn
      )                                 ;ende if
    )                                   ;ende defun


  (defun M:FEHLER (MSG)
    (princ
      (strcat "Fehler! AutoCAD meldet: \"" MSG "\" als Ursache.")
      ) ;_ end of princ
    (command "_.UNDO" "_BACK")
    (setq *ERROR* M:MD_ERR)
    (princ)
    ) ;_ end of defun


;;;*******************auswahl aller !! Elemente !! **************

  (if (setq ELEM1 (ssget "X"
                         '((-4 . "<OR")
                           (0 . "*LINE")
                           (0 . "ATTDEF")
                           (0 . "*TEXT")
                           (-4 . "OR>")
                           )
                         ) ;_ end of ssget
            ) ;_ end of setq
    (progn
      (repeat
        (sslength ELEM1)
         (setq POLY_ERSTE
                (entget (setq ENAME (ssname ELEM1 0)))
               ) ;_ end of setq
         (cond
           ((= (cdr (assoc 0 POLY_ERSTE)) "POLYLINE")
            (MD_2DPOLYLINE ENAME)
            )
           ((member (cdr (assoc 0 POLY_ERSTE)) '("SPLINE" "LWPOLYLINE"))
            (MD_LWPOLYLINE ENAME)
            )
           ((wcmatch (cdr (assoc 0 POLY_ERSTE)) "*TEXT")
            (MD_TEXT ENAME)
            )
           ((= (cdr (assoc 0 POLY_ERSTE)) "LINE")
            (md_LINE ENAME)
            )
           ((= (cdr (assoc 0 POLY_ERSTE)) "ATTDEF")
            (MD_ATTDEF ENAME)
            )
           ) ;_ end of cond
         (setq ELEM1 (ssdel ENAME ELEM1))
         ) ;_ end of repeat
      ) ;_ end of progn
    ) ;_ end of if
  (if (> (length L_LISTE) 0)
    (princ
      (strcat "\n" (itoa (length L_LISTE)) " Elemente gelscht !")
      ) ;_ end of princ
    (princ "\nKeine 0-Elemente gefunden")
    ) ;_ end of if
  (setvar "cmdecho" oldcmd)
  (setq *ERROR* M:MD_ERR)
  (princ)
  )                                     ;ende defun

